import 'package:flutter/widgets.dart';
import 'package:flutter_local_notifications/flutter_local_notifications.dart';
import 'package:rapidfire/Api.dart';
import 'package:rapidfire/Config.dart';
import 'package:workmanager/workmanager.dart';
import 'BGHelperDB.dart';
import 'Db.dart';

class ServiceRF {
  static runSyncService(IConfigRF config, Db db) {
    // Api().runSyncService(config, db);
  }
}

final dbHelper = BGHelperDB.instance;

startService(String jobName, Function callback, Map<String, dynamic> imputData) async {
  WidgetsFlutterBinding.ensureInitialized();
  await Workmanager.initialize(callback, isInDebugMode: false);
  await Workmanager.registerOneOffTask("1", jobName, inputData: imputData);
}

resetService(String serviceName) async {
  await dbHelper.deleteService(serviceName); // can be read
  Map<String, dynamic> row = {BGHelperDB.jobName: '$serviceName', BGHelperDB.jobCompleteStatus: 0};
  await dbHelper.insert(row);
  await dbHelper.update(serviceName, 0);
}

watchServiceCompleted(String serviceName) async {
  var ret = await dbHelper.get('select * from Config where JobName = ?', [serviceName]);
  return ret.first['CompleteStatus'];
}

notifyServiceCompleted(String serviceName) async {
  await dbHelper.update(serviceName, 1);
  notify('Server Data Operation Status:', 'Sync data has been successfully completed!');
}

//updateFetchHistory(int userID, String tableName, int pageNo, int isFetched) async {
//  var ret =
//      await dbHelper.get('select * from FetchHistory where TableName=? and PageNo=?', [tableName, pageNo]);
//  if (ret.length == 0)
//    dbHelper.insertFetchHistory(userID, tableName, pageNo, isFetched);
//  else
//    dbHelper.updateFetchHistory(userID, tableName, pageNo, isFetched);
//}

isAlreadyFetched(String tableName, int pageNo) async {
  bool isFetched = false;
  var ret =
      await dbHelper.get('select * from FetchHistory where TableName=? and PageNo=?', [tableName, pageNo]);
  if (ret.length > 0) {
    if (ret.first['IsFetched'] == 1) isFetched = true;
  }
  return isFetched;
}

notify(String title, String description) async {
  FlutterLocalNotificationsPlugin flp = FlutterLocalNotificationsPlugin();
  var android = AndroidInitializationSettings('@mipmap/ic_launcher');
  var iOS = IOSInitializationSettings();
  var initSettings = InitializationSettings(android, iOS);
  flp.initialize(initSettings);
  var androidDetails = AndroidNotificationDetails('channel id', 'channel NAME', 'CHANNEL DESCRIPTION',
      priority: Priority.High, importance: Importance.Max);
  var iOSDetails = IOSNotificationDetails();
  var platform = NotificationDetails(androidDetails, iOSDetails);
  await flp.show(0, title, description, platform, payload: 'description');
}
