import 'package:reflectable/mirrors.dart';
import 'Annotation.dart';
import 'GlobalScopeRF.dart';
import 'Config.dart';

class Dynamic {
  Object clazz = null;

  Dynamic([Object object]) {
    clazz = object;
  }

  setObject(Object object) {
    clazz = object;
  }

  Object create(String className) {} //BAD

  dynamic newClass() => classMirror.newInstance("", []);

  Object invoke(String methodName, String pram) => instanceMirror.invoke(methodName, ["Imrose"]); //BAD

  set(String name, Object value) {
    VariableMirror field;

    try {
      field = classMirror.declarations.values.where((e) => e.simpleName.contains(name)).toList().first;
    } catch (e) {
      field =
          classMirror.superclass.declarations.values.where((e) => e.simpleName.contains(name)).toList().first;
    }

    dynamic dVal = convertType(field.reflectedType, value);
    instanceMirror.invokeSetter(name, dVal);
  }

  Object get(String name) => instanceMirror.invokeGetter(name); //GET

  ClassMirror get classMirror {
    var ret;
    if (clazz is Type)
      ret = Model.reflectType(clazz);
    else
      ret = Model.reflectType(clazz.runtimeType);
    return ret;
  }

  InstanceMirror get instanceMirror => Model.reflect(clazz);

  dynamic convertType(Type type, Object value) {
    if (value == null) return null;
    if (type.toString().contains('String')) {
      return value.toString();
    } else if (type.toString().contains('double')) {
      return double.parse(value.toString().trim());
    } else if (type.toString().contains("byte[]")) {
      return null;
    } else if (type.toString().contains('int')) {
      return int.parse(value.toString().trim());
    } else if (type.toString().contains('bool')) {
      if (value is int)
        (value == 0) ? false : true;
      else
        return value;
    } else
      return value;
  }

  Map<String, dynamic> modelToDataMap() {
    // for save + get model json string
    Map<String, dynamic> modelData = {};
//    for (var v in classMirror.declarations.values) {
//      if (v is VariableMirror) {
//        modelData[v.simpleName] = get(v.simpleName);
//      }
//    }

    modelMembers.forEach((name, dynamic type) {
      if (!type.toString().contains('List<')) {
        modelData[name] = get(name);
      }
    });

    return modelData;
  }

  void dataMapToModel(Map<String, dynamic> json) {
    // for read + fill data in model
//    for (var v in classMirror.declarations.values) {
//      if (v is VariableMirror) {
//        if (!v.reflectedType.toString().contains('List<')) {
//          set(v.simpleName, json[v.simpleName]);
//        }
//      }
//    }

    modelMembers.forEach((name, dynamic type) {
      if (!type.toString().contains('List<')) {
        set(name, json[name]);
      }
    });
  }

  Object dataMapToNewModel(Map<String, dynamic> modelMap) {
    var newModel;
    Map<dynamic, dynamic> newModelMap = modelMap;
    ModelRF mrf = Libs.appModels.get()[clazz.runtimeType.toString()];
    newModel = Dynamic(mrf.model).newClass();
    newModelMap.forEach((key, value) {
      if (value is Map) {
        var model = Models.models[key].model;
        setObject(model);
        var x = dataMapToNewModel(value);
        Dynamic(newModel).set(key, x);
      } else
        Dynamic(newModel).set(key, value);
    });
    return newModel;
  }

  modelMembers1() {
    return null;
  }

  Map<String, Object> get modelMembers {
    Map<String, Object> data = Map();
    for (var v in classMirror.declarations.values) {
      if (v is VariableMirror) {
        data[v.simpleName] = v.reflectedType;
      }
    }

    try {
      classMirror.superclass.instanceMembers.forEach((_, value) {
        if (value.runtimeType.toString().contains('ImplicitGetterMirrorImpl')) {
          data[value.simpleName] = value.dynamicReflectedReturnType;
        }
      });
    } catch (e) {}

    return data;
  }

  List<String> get childModels {
    List<String> data = List();
//    for (var v in classMirror.declarations.values) {
//      if (v is VariableMirror) {
//        if (v.reflectedType.toString().contains('List<')) {
//          data.add(v.simpleName);
//        }
//      }
//    }

    modelMembers.forEach((name, dynamic type) {
      if (type.toString().contains('List<')) {
        data.add(name);
      }
    });

    return data;
  }

  List<Map> annotationData(Type annotationName) {
    //var dataList = {};
    List<Map> checkList = List();
    var annotationData = {};

    //Class Header
    classMirror.metadata.forEach((metadata) {
      if (metadata.runtimeType == annotationName) {
        print(get(metadata.runtimeType.toString()));
      }
    });

    //Variable Header
    for (var v in classMirror.declarations.values) {
      if (v is VariableMirror) {
        if (!v.metadata.isEmpty) {
          if (v.metadata.first.runtimeType == annotationName) {
            var data = {};
            data["field"] = v.simpleName;
            data["type"] = v.reflectedType;
            Object tmp = clazz;
            clazz = v.metadata.first;
            for (var av in classMirror.declarations.values) {
              if (av is VariableMirror) {
                annotationData[av.simpleName] = get(av.simpleName);
              }
            }
            data["data"] = annotationData;
            clazz = tmp;
            //dataList.addAll(data);
            checkList.add(data);
          }
        }
      }
    }

//          for (int i = 0; i < fields.length; i++) {
//            annotationData[fields[i]] = getter(fields[i]);
//          }

//    for (var v in classMirror.declarations.values) {
//
//    }
    return checkList;
  }

  // ==> Changed to modelMembers
  bool changed1() {
    var valueChanged = false;
    for (var v in classMirror.declarations.values) {
      if (v is VariableMirror) {
        if (get(v.simpleName) != null) valueChanged = true;
      }
    }
    return valueChanged;
  }

  Object copy() {
    var newObject = newClass();
    // var fff = classMirror;
    // var newObject = classMirror.newInstance("", []);

    for (var v in classMirror.declarations.values) {
      if (v is VariableMirror) {
        Dynamic(newObject).set(v.simpleName, get(v.simpleName));
      }
    }
    return newObject;
  }

  bool changed(Object objectToCompare) {
    var valueChanged = false;
    for (var v in classMirror.declarations.values) {
      if (v is VariableMirror) {
        if (Dynamic(objectToCompare).get(v.simpleName) != get(v.simpleName)) {
          valueChanged = true;
          break;
        }
      }
    }
    return valueChanged;
  }

//  List<ClassMirror> findSubClasses(Type type) {
//    MirrorSystem
//    ClassMirror classMirror = reflectClass(type);
//
//    return currentMirrorSystem()
//        .libraries
//        .values
//        .expand((lib) => lib.declarations.values)
//        .where((lib) {
//      return lib is ClassMirror &&
//          lib.isSubclassOf(classMirror) &&
//          lib != classMirror;
//    }).toList();
//  }
}

//flutter packages pub run build_runner build
