import 'package:flutter/material.dart';
import 'package:rapidfire/Annotation.dart';

import 'Dynamic.dart';
import 'GlobalScopeRF.dart';

class Required {
  final String msg;

  const Required([this.msg]);
}

class Range {
  final double start;
  final double end;

  const Range(this.start, this.end);
}

class Max {
}

class Email {
}

class Date {
}

class Custom {
  final fn;

  const Custom(this.fn);
}


class ValidationDataRF {
  bool isValid;
  String msg;

  ValidationDataRF(this.isValid, this.msg);
}

class ValidationRF {

  static String msg(String field) {
    return Libs.modelValidationData[field].msg;
  }

  static Widget showErrorMessage(String field) {
    bool valid = true;
    if (Libs.modelValidationData[field] == null)
      valid = true;
    else
      valid = Libs.modelValidationData[field].isValid;

    if (!valid)
      return Padding(
        padding: const EdgeInsets.only(top: 5, bottom: 15),
        child: Text(ValidationRF.msg(field),
          style: TextStyle(color: Colors.red),
        ),
      );
    else
      return Text('');
  }

  static List<Map> validationAnnotations;

  static ValidationDataRF validate(String field, Object model, dynamic value) {
    ValidationDataRF validationDataRF;

    var check = validationAnnotations; //Dynamic(model).getAnnotationData(Check);

    check.forEach((element) {
      for (var validation in element['data']['validations']) {
        if (validation is Required) {
          if (validationDataRF != null) break; //?
          if (element['field'] == field) {
            validationDataRF =
                validateField(element['field'], field, value, validation);
          } else
            return;
        }
      }
      if (validationDataRF != null) return;
    });
    return validationDataRF;
  }

  static ValidationDataRF validateField(String modelField, String checkField,
      dynamic checkFieldValue, dynamic validation) {
    ValidationDataRF validationDataRF;

    if (validation is Required) {
      if (modelField == checkField) {
        if (checkFieldValue == null) {
          validationDataRF = ValidationDataRF(
              false, validation.msg ?? '${checkField} is required.');
        } else if (checkFieldValue is String) {
          if (checkFieldValue.isEmpty) {
            validationDataRF = ValidationDataRF(
                false, validation.msg ?? '${checkField} is required.');
          }
        }

//        if (checkFieldValue == null || checkFieldValue.isEmpty) {
//          validationDataRF = ValidationDataRF(true,
//              (validation.msg == null || validation.msg.isEmpty)
//                  ? 'This field is required.'
//                  : validation.msg);
//        }
      }
    } else if (validation is Range) {
      // check reange and ret err msg
    }

    return validationDataRF;
  }


}

/*

CreditCard
This validates that the property has a credit card format.
Compare
This attribute validates that two property in model class match like password and compare password.
EmailAddress
This validates the property has email address format.
Phone
This validates that the property has a telephone number format.
Range
This validates that the property value within a specified range.
RegularExpression
This validates that the property value matches a specified regular expression.
Required
This validates that the field is not null
StringLength
This validates that a string property value doesn't exceed a specified length limit.
Url
This validates that the property has a URL format.
Remote
This validates input on the client by calling an action method on the server

*/