import 'package:flutter/material.dart';
import 'package:flutter/widgets.dart';
import 'package:rapidfire/uiux/intro/Models/page_view_model.dart';
import 'package:rapidfire/uiux/intro/intro_views_flutter.dart';
import 'package:rapidfire/stock/modern/onboarding/Login.dart';
import '../../../GlobalRF.dart';

class Intro extends StatefulWidget {
  List<IntroPageViewRF> pages;

  @override
  _IntroState createState() => _IntroState();
  Intro({this.pages});
}

class _IntroState extends State<Intro> {
//  final pagesX = [
//    IntroPageViewRF(
//      pageColor: const Color(0xFF03A9F4),
//      // iconImageAssetPath: 'assets/air-hostess.png',
//      bubble: Image.asset('assets/images/intro/air-hostess.png'),
//      body: Text('Haselfree  booking  of  flight  tickets  with  full  refund  on  cancelation'),
//      title: Text('Flights'),
//      titleTextStyle:
//          TextStyle(fontFamily: 'Raleway', fontWeight: FontWeight.w500, color: Colors.white),
//      bodyTextStyle:
//          TextStyle(fontFamily: 'Raleway', fontWeight: FontWeight.w500, color: Colors.white),
//      mainImage: Image.asset('assets/images/intro/home.png',
//          height: 285.0, width: 285.0, alignment: Alignment.center),
//    ),
//    IntroPageViewRF(
//      pageColor: const Color(0xFF8BC34A),
//      iconImageAssetPath: 'assets/images/intro/waiter.png',
//      body: Text(
//        'We  work  for  the  comfort ,  enjoy  your  stay  at  our  beautiful  hotels, another line',
//      ),
//      title: Text('Hotels'),
//      mainImage: Image.asset('assets/images/intro/mountain.png',
//          height: 285.0, width: 285.0, alignment: Alignment.center),
//      titleTextStyle:
//          TextStyle(fontFamily: 'Raleway', fontWeight: FontWeight.w500, color: Colors.white),
//      bodyTextStyle:
//          TextStyle(fontFamily: 'Raleway', fontWeight: FontWeight.w500, color: Colors.white),
//    ),
//    IntroPageViewRF(
//      pageColor: const Color(0xe5554bbb),
//      //Color(0xFF607D8B),
//      iconImageAssetPath: 'assets/images/intro/taxi-driver.png',
//      body: Text(
//        'Easy  cab  booking  at  your  doorstep  with  cashless  payment  system',
//      ),
//      title: Text('Cabs'),
//      mainImage: Image.asset('assets/images/intro/taxi.png',
//          height: 285.0, width: 285.0, alignment: Alignment.center),
//      titleTextStyle:
//          TextStyle(fontFamily: 'Raleway', fontWeight: FontWeight.w500, color: Colors.white),
//      bodyTextStyle:
//          TextStyle(fontFamily: 'Raleway', fontWeight: FontWeight.w500, color: Colors.white),
//    ),
//  ];

  @override
  Widget build(BuildContext context) {
    return IntroViewsFlutter(
      widget.pages,
      showNextButton: true,
      showBackButton: true,
      onTapDoneButton: () {
        rf.page.replace(context, rf.onboard.next()); //Login()
      },
      pageButtonTextStyles: TextStyle(
        color: Colors.white,
        fontSize: 18.0,
      ),
    );

    return MaterialApp(
      debugShowCheckedModeBanner: false, title: 'IntroViews Flutter', //title of app
      theme: ThemeData(
        primarySwatch: Colors.yellow,
      ), //ThemeData
      home: Builder(
        builder: (context) => IntroViewsFlutter(
          widget.pages,
          showNextButton: true,
          showBackButton: true,
          onTapDoneButton: () {
            rf.page.replace(context, rf.onboard.next()); //Login()
          },
          pageButtonTextStyles: TextStyle(
            color: Colors.white,
            fontSize: 18.0,
          ),
        ), //IntroViewsFlutter
      ), //Builder
    ); //Material App
  }
}
