import 'dart:async';

import 'package:flutter/cupertino.dart';
import 'package:flutter/material.dart';
import 'package:rapidfire/GlobalScopeRF.dart';
import 'package:rapidfire/UtilRF.dart';
import 'package:rapidfire/uiux/RipplesRF.dart';
import 'package:rapidfire/uiux/WidgetsRF.dart';

import '../../../GlobalRF.dart';

class Splash extends StatefulWidget {
  SplashRF splash;
  Splash({this.splash});

  @override
  _SplashState createState() => _SplashState();
}

class _SplashState extends State<Splash> {
  @override
  Widget build(BuildContext context) {
    var title = widget.splash?.title ?? Libs.config.app.title;
    var subTitle = widget.splash?.subTitle ?? Libs.config.app.subTitle;
    var color = widget.splash?.color ?? Colors.pink;
    var font = widget.splash?.font ?? 'Raleway';
    var colorSubTitle = widget.splash?.subTitleColor ?? Colors.black;
    var rippleImagePath = widget.splash?.rippleImagePath ?? 'assets/images/child.png';
    var rippleColor = widget.splash?.rippleColor ?? widget.splash?.color ?? Colors.pink;
    var orgLogoPath = widget.splash?.orgLogoPath ?? 'assets/images/sci.png';

    Timer(Duration(seconds: widget.splash?.duration ?? 5),
        () => rf.page.replace(context, rf.onboard.next())); //Intro()
    return Material(
      color: Colors.white, //alignment: Alignment(0, 0),
      child: Column(
        mainAxisSize: MainAxisSize.min,
        crossAxisAlignment: CrossAxisAlignment.center,
        mainAxisAlignment: MainAxisAlignment.start,
        children: <Widget>[
          SizedBox(
            height: 80,
          ),
          Expanded(
            child: Text(title,
                style: TextStyle(
                    fontFamily: 'Berlin Sans FB Demi Bold',
                    color: color,
                    fontSize: 40,
                    fontWeight: FontWeight.bold)),
            flex: 6,
          ),
          Expanded(
            child: Text(subTitle, //'Development framework for mobile',
                style: TextStyle(
                    fontFamily: font, fontSize: 18, color: colorSubTitle, fontWeight: FontWeight.w500)),
            flex: 5,
          ),
          Expanded(
            child: Align(
              alignment: Alignment.topCenter,
              child: Padding(
                  padding: EdgeInsets.only(top: 120), child: ripple(context, rippleColor, rippleImagePath)),
            ),
            flex: 75,
          ),
          Expanded(
            child: Padding(
              padding: const EdgeInsets.all(20.0),
              child: widget.splash?.orgLogoPath == null
                  ? UtilRF.libImage(orgLogoPath, 'rapidfire')
                  : Image.asset(orgLogoPath),
            ),
            flex: 10,
          ),
        ],
      ),
    );
  }
}

Widget ripple(BuildContext context, Color color, String imagePath) {
  return RipplesRF(
    color: color,
    child: Container(
      decoration: BoxDecoration(
        color: Colors.transparent,
      ),
      padding: EdgeInsets.symmetric(horizontal: 4.0),
      width: MediaQuery.of(context).size.width * 0.2,
      child: Image.asset(
        imagePath,
        alignment: Alignment.centerLeft,
      ),
    ),
  );
}
