import 'package:flutter/material.dart';
import 'package:flutter/widgets.dart';
import 'package:rapidfire/uiux/swl/sweetalert.dart';

//              return AlertRF(
//                  context: context,
//                  title: 'Confirm',
//                  icon: Icons.error,
//                  msg: 'Save change pending, do you want to quite anyway?',
//                  confirmText: 'DO NOT SAVE',
//                  onConfirm: (value) {
//                    if (value) Navigator.pop(context);
//                  }).show();

class AlertRF_RND extends StatefulWidget {
  Function onConfirm;

  @override
  _AlertRF_RNDState createState() => _AlertRF_RNDState();

  AlertRF_RND({this.onConfirm});
}

class _AlertRF_RNDState extends State<AlertRF_RND> {
  @override
  Widget build(BuildContext context) {
    return AlertDialog(
      title: Row(
          children: [
            Image.network('https://flutter-examples.com/wp-content/uploads/2019/12/android_icon.png',
              width: 50, height: 50, fit: BoxFit.contain,),
            Text('  Alert Dialog Title. ')
          ]
      ),
      content: Text("Are You Sure Want To Proceed?"),
      actions: <Widget>[
        FlatButton(
          child: Text("YES"),
          onPressed: () {
            widget.onConfirm(true);
            //Put your code here which you want to execute on Yes button click.
            Navigator.of(context).pop(true);
          },
        ),

        FlatButton(
          child: Text("CANCEL"),
          onPressed: () {
            widget.onConfirm(false);
            //Put your code here which you want to execute on Cancel button click.
            Navigator.of(context).pop(false);
          },
        ),
      ],
    );
  }
}


class AlertRF {
  BuildContext context;
  String title;
  IconData icon;
  String msg;
  String confirmText;
  String cancelText;
  Function onConfirm;

  AlertRF({@required this.context, this.title,
            @required this.msg, this.icon, this.confirmText = 'OK',
            this.cancelText = 'CANCEL', this.onConfirm});

  show() async {
    return await showDialog(
      context: context,
      builder: (BuildContext context) {
        return AlertDialog(
          title: Padding(
            padding: const EdgeInsets.only(left: 15, right: 15),
            child: Column(
              children: <Widget>[
                Icon(icon, size: 64, color: Colors.deepOrange,),
                SizedBox(height: 5,),
                Text(title)
              ],
            ),
          ),
          content: Text(msg),
          actions: <Widget>[
            FlatButton(
                onPressed: () {
                  onConfirm(true);
                  Navigator.of(context).pop(true);
                },
                child: Text(confirmText)
            ),
            FlatButton(
              onPressed: () {
                onConfirm(false);
                Navigator.of(context).pop(false);
              },
              child: Text(cancelText),
            ),
          ],
        );
      },
    );
  }

  static sh(BuildContext context, Function fn) async {
    return await showDialog(
      context: context,
      builder: (BuildContext context) {
        return AlertDialog(
          title: const Text("Confirm"),
          content: const Text("Are you sure you wish to delete this item?"),
          actions: <Widget>[
            FlatButton(
                onPressed: () {
                  Navigator.of(context).pop(true);
                  fn(true);
                },
                child: const Text("DELETE")
            ),
            FlatButton(
              onPressed: () {
                Navigator.of(context).pop(false);
                fn(false);
              },
              child: const Text("CANCEL"),
            ),
          ],
        );
      },
    );
  }

  static showSA(BuildContext context, String msg, Function onConfirm) {
    SweetAlert.show(context,
        title: msg,
        style: SweetAlertStyle.confirm,
        showCancelButton: true,
        onPress: (bool isConfirm) {
          if (isConfirm) {
            //SweetAlert.show(context, style: SweetAlertStyle.success, title: "Success");
            // return false to keep dialog
            return onConfirm(isConfirm);
          }
          return onConfirm(isConfirm);
        });
  }

}

class abc extends StatefulWidget {
  @override
  _abcState createState() => _abcState();
}

class _abcState extends State<abc> {
  @override
  Widget build(BuildContext context) {

  }
}
