import 'package:flutter/material.dart';
import '../Extensions.dart';
import '../GlobalScopeRF.dart';

//enum TemplateNameRF { material, cupertino, modern, classic }
enum TemplateNameRF { material, cupertino, modern, classic }

class TemplateRF {
  TemplateNameRF name;
  String version;
  StyleRF style;
  dynamic directives;


  TemplateRF(this.name, {this.version, this.style, this.directives}) {
    if (this.name == null) this.name = TemplateNameRF.modern;
  }

  static TemplateRF get([TemplateRF template]) {
    if (template == null) return Libs.config.app.template ?? TemplateRF(TemplateNameRF.modern);

    if (template is TemplateRF) return template;

//    if (template is TemplateNameRF) {
//      return TemplateRF(template);
//    }
//
//    if (template is List) {
//      if (template.length == 0) {
//        return TemplateRF(TemplateNameRF.modern);
//      } else if (template.length == 1) {
//        return TemplateRF(template[0]);
//      } else if (template.length == 2) {
//        return TemplateRF(template[0], template[1]);
//      }
//    }
  }
}

class AppStyles {
  AppThemeStyleRF theme = AppThemeStyleRF();
  ColorRF color = ColorRF();
  GradientRF gradient = GradientRF();
  ShadowRF shadow = ShadowRF();
}

class StyleRF {
  static AppThemeStyleRF theme = AppThemeStyleRF();
  static ColorRF colors = ColorRF();
  static GradientRF gradients = GradientRF();
  static ShadowRF shadows = ShadowRF();

  Color color;
  double size;
  String font;
  FontWeight weight;
  Color borderColor;
  int borderWidth;
  int borderRadius;
  int backgroundColor;
  List<BoxShadow> shadow;

  StyleRF({
    this.color,
    this.size,
    this.font,
    this.weight,
    this.borderColor,
    this.borderWidth,
    this.borderRadius,
    this.backgroundColor,
    this.shadow,
  });
}

class AppThemeStyleRF {
  @override
  bool operator +(other) {
    // compare this to other
  }

  var clientTheme = Libs.config.app.template;
  var clientStyle = Libs.config.app.theme;

  TextStyle appTitle([dynamic template]) {
    switch (TemplateRF.get(template).name) {
      case TemplateNameRF.modern:
        return TextStyle(
          color: clientStyle?.appTitle?.color ?? Colors.pink,
          fontSize: clientStyle?.appTitle?.size ?? 35,
          fontWeight: clientStyle?.appTitle?.weight ?? FontWeight.bold,
          fontFamily: clientStyle?.appTitle?.font ?? 'Berlin Sans FB Demi Bold',
          //letterSpacing: 1,
          decoration: TextDecoration.none,
          shadows: [ShadowRF.shadow1PX],
        );
    }
  }

  TextStyle appSubTitle([dynamic template]) {
    switch (TemplateRF.get(template).name) {
      case TemplateNameRF.modern:
        return TextStyle(
          color: clientStyle?.appSubTitle?.color ?? '484848'.toColor,
          fontSize: clientStyle?.appSubTitle?.size ?? 15,
          fontWeight: clientStyle?.appSubTitle?.weight ?? FontWeight.bold,
          fontFamily: clientStyle?.appSubTitle?.font ?? 'Berlin Sans FB Demi Bold',
          decoration: TextDecoration.none,
        );
    }
  }

  TextStyle pageTitle([TemplateRF template]) {
    switch (TemplateRF.get(template).name) {
      case TemplateNameRF.modern:
        return TextStyle(
          color: template?.style?.color ?? clientStyle?.pageTitle?.color ?? Colors.black54,
          fontSize: template?.style?.size ?? clientStyle?.pageTitle?.size ?? 20,
          fontWeight: clientStyle?.pageTitle?.weight ?? FontWeight.bold,
          fontFamily: clientStyle?.pageTitle?.font ?? 'Roboto',
          letterSpacing: 1,
          decoration: TextDecoration.none,
        );
    }
  }

  TextStyle pageSubTitle([dynamic template]) {
    switch (TemplateRF.get(template).name) {
      case TemplateNameRF.modern:
        return TextStyle(
          color: template?.style?.color ?? clientStyle?.pageSubTitle?.color ?? Colors.black54,
          fontSize: template?.style?.size ?? clientStyle?.pageSubTitle?.size ?? 18,
          fontWeight: clientStyle?.pageSubTitle?.weight ?? FontWeight.bold,
          fontFamily: clientStyle?.pageSubTitle?.font ?? 'Raleway',
          letterSpacing: 1,
          decoration: TextDecoration.none,
        );
    }
  }

  TextStyle pageSegmentTitle([dynamic template]) {
    switch (TemplateRF.get(template).name) {
      case TemplateNameRF.modern:
        return TextStyle(
          color: clientStyle?.pageSubTitle?.color ?? Colors.black,
          fontSize: clientStyle?.pageSubTitle?.size ?? 18,
          fontWeight: clientStyle?.pageSubTitle?.weight ?? FontWeight.bold,
          fontFamily: clientStyle?.pageSubTitle?.font ?? 'Roboto',
          letterSpacing: 1,
          decoration: TextDecoration.none,
        );
    }
  }


  TextStyle label([dynamic template]) {
    switch (TemplateRF.get(template).name) {
      case TemplateNameRF.modern:
        return TextStyle(
          color: clientStyle?.pageSubTitle?.color ?? Colors.black,
          fontSize: clientStyle?.pageSubTitle?.size ?? 14,
          fontWeight: clientStyle?.pageSubTitle?.weight ?? FontWeight.bold,
          fontFamily: clientStyle?.pageSubTitle?.font ?? 'Roboto',
          letterSpacing: 1,
          decoration: TextDecoration.none,
        );
    }
  }
}

class ThemeRF {
  StyleRF widgets;
  Color color;

  //FontFace font;
  StyleRF appTitle;
  StyleRF appSubTitle;
  StyleRF pageTitle;
  StyleRF pageSubTitle;
  StyleRF pageSegmentTitle;
  StyleRF pageSegmentSubTitle;
  StyleRF label;
  StyleRF error;
  StyleRF info;
  StyleRF warning;
  StyleRF headline1;
  StyleRF headline6;
  StyleRF button1;
  StyleRF button2;
  StyleRF button3;

  ThemeRF(
      {this.widgets,
      this.color, //  this.font,
      this.appTitle,
      this.appSubTitle,
      this.pageTitle,
      this.pageSubTitle,
      this.pageSegmentTitle,
      this.pageSegmentSubTitle,
      this.label,
      this.error,
      this.info,
      this.warning,
      this.headline1,
      this.headline6,
      this.button1,
      this.button2,
      this.button3});
}

class ColorRF {
  var danger;
}

class ShadowRF {
  static var shadow1PX = Shadow(
    blurRadius: 1.0,
    color: Colors.black45,
    offset: Offset(1.0, 1.0),
  );
}

class GradientRF {
  topLightBottomDark(String colorTop, String colorBottom) {
    var _colorTop = colorTop.toColor;
    var _colorBottom = colorBottom.toColor;
    return BoxDecoration(
      gradient: LinearGradient(
        begin: Alignment.topLeft,
        end: Alignment.bottomRight,
        colors: [
          Color.fromRGBO(_colorTop.red, _colorTop.green, _colorTop.blue, 1.0),
          Color.fromRGBO(_colorBottom.red, _colorBottom.green, _colorBottom.blue, 1.0),
        ],
        tileMode: TileMode.repeated,
      ),
    );
  }
}

//44, 72, 171, 1.0 //234, 43, 109, 1.0
